;//////////////////////////////////////////////////////////////////////////////
;// * File name: csl_init.asm
;// *                                                                          
;// * Description: This file includes csl_initialization for minimum power 
;//	*              consumption.
;// *                                                                          
;// * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
;// *                                                                          
;// *                                                                          
;// *  Redistribution and use in source and binary forms, with or without      
;// *  modification, are permitted provided that the following conditions      
;// *  are met:                                                                
;// *                                                                          
;// *    Redistributions of source code must retain the above copyright        
;// *    notice, this list of conditions and the following disclaimer.         
;// *                                                                          
;// *    Redistributions in binary form must reproduce the above copyright     
;// *    notice, this list of conditions and the following disclaimer in the   
;// *    documentation and/or other materials provided with the                
;// *    distribution.                                                         
;// *                                                                          
;// *    Neither the name of Texas Instruments Incorporated nor the names of   
;// *    its contributors may be used to endorse or promote products derived   
;// *    from this software without specific prior written permission.         
;// *                                                                          
;// *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     
;// *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       
;// *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   
;// *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    
;// *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   
;// *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        
;// *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   
;// *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   
;// *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     
;// *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   
;// *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    
;// *                                                                          
;//////////////////////////////////////////////////////////////////////////////

       .mmregs

       .include "lpva200.inc"

       .def    _c5515_init
       .text

_c5515_init: 
		.if 1
		bit(ST1, #11) = #1		; Disable interrupts
	   	bit(ST3,#7) = #0		; Clear bus error interrupts
   	    bit(ST3,#2) = #1		; shut off clockout port
	   	bit(ST1,#13) = #0		; shut off XF port
	   	.endif
		
		.if 1
		 *port(#IDLE_ICR) = #(RESERVED_ICR|IPORT_IDLE|HWA_IDLE|DPORT_IDLE)
		idle

		*port(#IDLE_PCGCR) = #RESERVED_PCGCR         ; bring all peripherals out of idle
        *port(#IDLE_PCGCR_MSW) = #RESERVED_PCGCR_MSW
		idle
        .endif	   	

		.if 1 ; increases IO1 current a little
		*port(#PERIPHSEL0) = #0x0A00 ; external bus selection PARALLEL port all LCD, rest GPIO
		.endif

		.if 1
		*port(#GPIO_DIR0)  = #0x07FF ; 0 - input 1- output
		*port(#GPIO_DIR1)  = #0x07FF ; 0 - input 1- output
		*port(GPIO_DOUT0)  = #0x0000 ; set output to 0              
		*port(GPIO_DOUT1)  = #0x0000 ; set output to 0   
        .endif
                
		.if 1
		*port(#RTC_OSC)    = #0x0008 ; put RTC in least current mode  
        *port(#RTC_PMGT)   = #0x0000 ; RTC clk out diabled
		.endif

		.if 1
        *port(#PER_RSTCOUNT) = 2     ; set peripheral reset count
        repeat(#(6-1))
        nop

        *port(#PER_RESET) = 0x00FB   ; reset peripherals
        repeat(#(6-1))
        nop
        .endif
        
		.if 1
		;turn off clock out (set to 3)
		*port(#CLKOUT_CFG)= #0x0; 
		.endif

		.if 1 ;  greatly affects IO2 current
        ; gate clock for all peripherals
        *port(#CLKSTOP) = #(EMIF_CLKSTOP_REQ|USB_CLKSTOP_REQ|UART_CLKSTOP_REQ)        
Wait_Ack:                     
        repeat(#(10-1))
        nop
        AC0 = *port(#CLKSTOP)
        AC0 = AC0 - #(EMIF_CLKSTOP_REQ|EMIF_CLKSTOP_ACK|USB_CLKSTOP_REQ|USB_CLKSTOP_ACK|UART_CLKSTOP_REQ|UART_CLKSTOP_ACK)
        if(AC0 != #0) goto Wait_Ack	
        .endif

		; Idle peripherals clock gating control
		.if 1
        *port(#IDLE_PCGCR) = #(IIS3_IDLE | SPI_IDLE | UART_IDLE | DMA0_IDLE | MMCSD0_IDLE | COPROC_IDLE | MMCSD1_IDLE | IIS0_IDLE | IIS1_IDLE | TIMER0_IDLE | EMIF_IDLE | TIMER1_IDLE | TIMER2_IDLE | IIS2_IDLE | RESERVED_PCGCR)
        *port(#IDLE_PCGCR_MSW) = #( SARADC_IDLE | USB_IDLE | DMA1_IDLE | DMA2_IDLE | DMA3_IDLE | RESERVED_PCGCR_MSW)
        *port(#IDLE_ICR) = #(IPORT_IDLE|DPORT_IDLE | HWA_IDLE | MPORT_IDLE | RESERVED_ICR) ; cannot idle  XPORT when CPU not idled
        repeat(#(6-1))
        nop
        idle
		repeat(#(6-1))
        nop	
        .endif     

		*port(#USB_CNTL) |= #0x8000       ; USB Power Down
	  
	  	*port(#USB_ANA_CNTL) = #0		  ; USB LDO disabled
		 		
    .end
