;//////////////////////////////////////////////////////////////////////////////
;// * File name: lpva200.inc
;// *                                                                          
;// * Description: System register include file
;// *                                                                          
;// * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
;// *                                                                          
;// *                                                                          
;// *  Redistribution and use in source and binary forms, with or without      
;// *  modification, are permitted provided that the following conditions      
;// *  are met:                                                                
;// *                                                                          
;// *    Redistributions of source code must retain the above copyright        
;// *    notice, this list of conditions and the following disclaimer.         
;// *                                                                          
;// *    Redistributions in binary form must reproduce the above copyright     
;// *    notice, this list of conditions and the following disclaimer in the   
;// *    documentation and/or other materials provided with the                
;// *    distribution.                                                         
;// *                                                                          
;// *    Neither the name of Texas Instruments Incorporated nor the names of   
;// *    its contributors may be used to endorse or promote products derived   
;// *    from this software without specific prior written permission.         
;// *                                                                          
;// *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     
;// *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       
;// *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   
;// *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    
;// *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   
;// *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        
;// *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   
;// *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   
;// *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     
;// *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   
;// *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    
;// *                                                                          
;//////////////////////////////////////////////////////////////////////////////



; *******************************************************************************************
; *******************************************************************************************
; *****  SYSREG Registers:               (IO Space:  0x1C00 - 0x1CFF)
; *******************************************************************************************
; *******************************************************************************************
PERIPHSEL0              .set    0x1C00
    ; PERIPHSEL0   Address:  0x1C00 (IO Space)           PERIPHSEL0 (Peripheral Pin Mapping Register 0)
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  SEL_GPIO21_nA15
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  SEL_GPIO22_nA16
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  SEL_GPIO23_nA17
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  SEL_GPIO24_nA18
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  SEL_GPIO25_nA19
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  SEL_GPIO26_nA20
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  SEL_S0[0]
    ;   |  |  |  |  |  |  +----------------------------- [9]  SEL_S0[1]
    ;   |  |  |  |  |  +-------------------------------- [10] SEL_S1[0]
    ;   |  |  |  |  +----------------------------------- [11] SEL_S1[1]
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] SEL_P[0]
    ;   |  |  +----------------------------------------- [13] SEL_P[1]
    ;   |  +-------------------------------------------- [14] SEL_P[2]
    ;   +----------------------------------------------- [15] reserved


IDLE_PCGCR              .set    0x1C02
    ; IDLE_PCGCR   Address:  0x1C02 (IO Space)           Peripheral Clock Gating Control Register LSW
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  IIS3_IDLE         (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  SPI_IDLE          (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  UART_IDLE         (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  DMA0_IDLE         (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  MMCSD0_IDLE       (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  COPROC_IDLE       (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  I2C_IDLE          (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  MMCSD1_IDLE       (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  IIS0_IDLE         (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  |  +----------------------------- [9]  IIS1_IDLE         (0:clk active, 1:clk disabled)
    ;   |  |  |  |  |  +-------------------------------- [10] TIMER0_IDLE       (0:clk active, 1:clk disabled)
    ;   |  |  |  |  +----------------------------------- [11] EMIF_IDLE         (0:clk active, 1:clk disabled)
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] TIMER1_IDLE       (0:clk active, 1:clk disabled)
    ;   |  |  +----------------------------------------- [13] TIMER2_IDLE       (0:clk active, 1:clk disabled)
    ;   |  +-------------------------------------------- [14] IIS2_IDLE         (0:clk active, 1:clk disabled)
    ;   +----------------------------------------------- [15] MASTER_CLK_DIS    (0:Master clock active, 1:all clks disabled)

;----------------------------------------------------------------------------------------
;        IDLE_PCGCR         Bit Fields
;----------------------------------------------------------------------------------------
IIS3_IDLE           .set    1b<<0       ; IIS3 Idle Control Bit
SPI_IDLE            .set    1b<<1       ; SPI Idle Control Bit
UART_IDLE           .set    1b<<2       ; UART Control Bit
DMA0_IDLE           .set    1b<<3       ; DMA0 Idle Control Bit
MMCSD0_IDLE         .set    1b<<4       ; MMCSD0 Idle Control Bit
COPROC_IDLE         .set    1b<<5       ; CoProcessor Idle Control Bit
I2C_IDLE            .set    1b<<6       ; I2C Idle Control Bit
MMCSD1_IDLE         .set    1b<<7       ; MMCSD0 Idle Control Bit
IIS0_IDLE           .set    1b<<8       ; I2S0 Idle Control Bit
IIS1_IDLE           .set    1b<<9       ; I2S1 Idle Control Bit
TIMER0_IDLE         .set    1b<<10      ; Timer 0 Idle Control Bit
EMIF_IDLE           .set    1b<<11      ; EMIF Idle Control Bit
TIMER1_IDLE         .set    1b<<12      ; Timer 1 Module Clock off
TIMER2_IDLE         .set    1b<<13      ; Timer 2 Module Clock off
IIS2_IDLE           .set    1b<<14      ; IIS2 Idle Control Bit
OSC_DISABLE         .set    1b<<15      ; Oscillator disable      (cory: use of this name should be discontinued... use 'MASTER_CLK_DIS')
MASTER_CLK_DIS      .set    1b<<15      ; Disables clock to ALL domains (can only wake via: RTC alarms, WAKEUP, INT0, INT1, & RESET)
RESERVED_PCGCR      .set    0000000000000000b       ; Reserved bits (MSB --> LSB)

IDLE_PCGCR_MSW          .set    0x1C03
    ; IDLE_PCGCR_MSW   Address:  0x1C03 (IO Space)           Peripheral Clock Gating Control Register MSW
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  LCD_CG        (0:active, 1:disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  SAR_CG        (0:active, 1:disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  USB_CG        (0:active, 1:disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  DMA1_CG       (0:active, 1:disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  DMA2_CG       (0:active, 1:disabled)
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  DMA3_CG       (0:active, 1:disabled)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  ANAREG_CG     (0:active, 1:disabled) (note: SAR_CG==0 then this reg is ignored and the ANAREG clocks are forced ON).
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved

;----------------------------------------------------------------------------------------
;        IDLE_PCGCR_MSW         Bit Fields
;----------------------------------------------------------------------------------------
LCD_IDLE            .set    1b<<0       ; LCD Idle Control Bit
SARADC_IDLE         .set    1b<<1       ; SAR A/D Idle Control Bit
USB_IDLE            .set    1b<<2       ; USB Idle Control Bit
DMA1_IDLE           .set    1b<<3       ; DMA1 Idle Control Bit
DMA2_IDLE           .set    1b<<4       ; DMA2 Idle Control Bit
DMA3_IDLE           .set    1b<<5       ; DMA3 Idle Control Bit
ANAREG_IDLE         .set    1b<<6       ; ANAREG Idle Control Bit
RESERVED_PCGCR_MSW  .set    1111111110000000b       ; Reserved bits


PER_RSTCOUNT            .set    0x1C04
    ; PER_RSTCOUNT   Address:  0x1C04 (IO space)          Peripheral Software Reset Counter Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  PeripheralsResetCount[0]
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  PeripheralsResetCount[1]
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  PeripheralsResetCount[2]
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  PeripheralsResetCount[3]
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  PeripheralsResetCount[4]
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  PeripheralsResetCount[5]
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  PeripheralsResetCount[6]
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  PeripheralsResetCount[7]
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  PeripheralsResetCount[8]
    ;   |  |  |  |  |  |  +----------------------------- [9]  PeripheralsResetCount[9]
    ;   |  |  |  |  |  +-------------------------------- [10] PeripheralsResetCount[10]
    ;   |  |  |  |  +----------------------------------- [11] PeripheralsResetCount[11]
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] PeripheralsResetCount[12]
    ;   |  |  +----------------------------------------- [13] PeripheralsResetCount[13]
    ;   |  +-------------------------------------------- [14] PeripheralsResetCount[14]
    ;   +----------------------------------------------- [15] PeripheralsResetCount[15]

PER_RESET               .set    0x1C05
    ; PER_RESET   Address:  0x1C05 (IO space)             Peripheral Reset Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+       Note:  Order matters.  Write to PeripheralsResetCount[15:0] first, then this register.
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |               ******* WRITES TO THIS REGISTER ********
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  ResetEn_I2C                         (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  ResetEn_EMIF_Timers_RTC             (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  ResetEn_Analog_SAR  (& TRIM!!!)     (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1)) (Customers should never reset this domain because of its effect on trim!!)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  ResetEn_USB                         (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  ResetEn_DMA                         (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  ResetEn_MMCSD0_MMCSD1_IIS0_IIS1     (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  ResetEn_FFTCOP                      (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  ResetEn_LCD_IIS2_IIS3_UART_SPI      (0:reset left not asserted, 1:reset asserted for count cycles (HoldInReset==0) or indefinitely (HoldInReset==1))
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  HoldInReset_I2C                     (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  |  |  |  |  |  +----------------------------- [9]  HoldInReset_EMIF_TIMERS_RTC         (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  |  |  |  |  +-------------------------------- [10] HoldInReset_Analog_SAR  (& TRIM!!!) (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  |  |  |  +----------------------------------- [11] HoldInReset_USB                     (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] HoldInReset_DMA                     (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  |  +----------------------------------------- [13] HoldInReset_MMCSD0_MMCSD1_IIS0_IIS1 (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  +-------------------------------------------- [14] HoldInReset_FFTCOP                  (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   +----------------------------------------------- [15] HoldInReset_LCD_IIS2_IIS3_UART_SPI  (0:hold in reset for PeripheralsResetCount[15:0] cycles, 1:hold in reset indefinitely)  (note ResetEn must also be written with a 1 to hold indefinitely)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |               ******* READS FROM THIS REGISTER ********
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  ResetState_I2C                      (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  ResetState_EMIF_Timers_RTC          (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  ResetState_Analog_SAR               (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  ResetState_USB                      (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  ResetState_DMA                      (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  ResetState_MMCSD0_MMCSD1_IIS0_IIS1  (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  ResetState_FFTCOP                   (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  ResetState_LCD_IIS2_IIS3_UART_SPI   (read returns current state of peripheral's RESET REQUEST (0: not in reset, 1:peripheral is in reset))
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  HoldInReset_I2C                     (read returns the value last written)
    ;   |  |  |  |  |  |  +----------------------------- [9]  HoldInReset_EMIF_Timers_RTC         (read returns the value last written)
    ;   |  |  |  |  |  +-------------------------------- [10] HoldInReset_Analog_SAR              (read returns the value last written)
    ;   |  |  |  |  +----------------------------------- [11] HoldInReset_USB                     
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] HoldInReset_DMA                     (read returns the value last written)
    ;   |  |  +----------------------------------------- [13] HoldInReset_MMCSD0_MMCSD1_IIS0_IIS1 (read returns the value last written)
    ;   |  +-------------------------------------------- [14] HoldInReset_FFTCOP                  (read returns the value last written)
    ;   +----------------------------------------------- [15] HoldInReset_LCD_IIS2_IIS3_UART_SPI  (read returns the value last written)

;----------------------------------------------------------------------------------------
;        PER_RESET      Bit Fields
;----------------------------------------------------------------------------------------
I2C_RST                         .set    1b<<0       ; I2C Reset Bit
EMIF_TIMERS_RTC_RST             .set    1b<<1       ; EMIF_TIMERS_RTC Reset Bit
SAR_RST                         .set    1b<<2       ; SAR Reset Bit
USB_RST                         .set    1b<<3       ; USB Reset Bit
DMA_RST                         .set    1b<<4       ; DMA Reset Bit
MMCSD0_MMCSD1_IIS0_IIS1_RST     .set    1b<<5       ; MMCSD0_MMCSD1_IIS0_IIS1 Reset Bit
FFTCOP_RST                      .set    1b<<6       ; FFT CoProcessor Reset Bit
LCD_IIS2_IIS3_UART_SPI_RST      .set    1b<<7       ; LCD_IIS2_IIS3_UART_SPI Reset Bit



GPIO_DIR0               .set    0x1C06
GPIO_DIR                .set    0x1C06
    ; GPIO_DIR0/GPIO_DIR   Address:  0x1C06 (IO space)             GPIO Direction Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  GPIO_DIR[0]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  GPIO_DIR[1]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  GPIO_DIR[2]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  GPIO_DIR[3]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  GPIO_DIR[4]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  GPIO_DIR[5]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  GPIO_DIR[6]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  GPIO_DIR[7]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  GPIO_DIR[8]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  +----------------------------- [9]  GPIO_DIR[9]   (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  +-------------------------------- [10] GPIO_DIR[10]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  +----------------------------------- [11] GPIO_DIR[11]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] GPIO_DIR[12]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  +----------------------------------------- [13] GPIO_DIR[13]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  +-------------------------------------------- [14] GPIO_DIR[14]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   +----------------------------------------------- [15] GPIO_DIR[15]  (0:gpio pin is an input, 1:gpio pin is an output)

GPIO_DIR1               .set    0x1C07
    ; GPIO_DIR1   Address:  0x1C07 (IO space)
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  GPIO_DIR[16]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  GPIO_DIR[17]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  GPIO_DIR[18]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  GPIO_DIR[19]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  GPIO_DIR[20]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  GPIO_DIR[21]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  GPIO_DIR[22]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  GPIO_DIR[23]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  GPIO_DIR[24]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  |  +----------------------------- [9]  GPIO_DIR[25]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  |  +-------------------------------- [10] GPIO_DIR[26]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |  +----------------------------------- [11] GPIO_DIR[27]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] GPIO_DIR[28]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  |  +----------------------------------------- [13] GPIO_DIR[29]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   |  +-------------------------------------------- [14] GPIO_DIR[30]  (0:gpio pin is an input, 1:gpio pin is an output)
    ;   +----------------------------------------------- [15] GPIO_DIR[31]  (0:gpio pin is an input, 1:gpio pin is an output)




GPIO_DIN0               .set    0x1C08
GPIO_DIN                .set    0x1C08
    ; GPIO_DIN0/GPIO_DIN   Address:  0x1C08 (IO space)             GPIO Data In Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :r |r :r :r :r |  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | ?: ?: ?: ?| ?: ?: ?: ?| ?: ?: ?: ?| ?: ?: ?: ?|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  GPIO_DIN[0]   data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  GPIO_DIN[1]   data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  GPIO_DIN[2]   data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  GPIO_DIN[3]   data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  GPIO_DIN[4]   data in value
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  GPIO_DIN[5]   data in value
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  GPIO_DIN[6]   data in value
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  GPIO_DIN[7]   data in value
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  GPIO_DIN[8]   data in value
    ;   |  |  |  |  |  |  +----------------------------- [9]  GPIO_DIN[9]   data in value
    ;   |  |  |  |  |  +-------------------------------- [10] GPIO_DIN[10]  data in value
    ;   |  |  |  |  +----------------------------------- [11] GPIO_DIN[11]  data in value
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] GPIO_DIN[12]  data in value
    ;   |  |  +----------------------------------------- [13] GPIO_DIN[13]  data in value
    ;   |  +-------------------------------------------- [14] GPIO_DIN[14]  data in value
    ;   +----------------------------------------------- [15] GPIO_DIN[15]  data in value

GPIO_DIN1               .set    0x1C09
    ; GPIO_DIN1   Address:  0x1C09 (IO space)
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :r |r :r :r :r |  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | ?: ?: ?: ?| ?: ?: ?: ?| ?: ?: ?: ?| ?: ?: ?: ?|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  GPIO_DIN[16]  data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  GPIO_DIN[17]  data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  GPIO_DIN[18]  data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  GPIO_DIN[19]  data in value
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  GPIO_DIN[20]  data in value
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  GPIO_DIN[21]  data in value
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  GPIO_DIN[22]  data in value
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  GPIO_DIN[23]  data in value
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  GPIO_DIN[24]  data in value
    ;   |  |  |  |  |  |  +----------------------------- [9]  GPIO_DIN[25]  data in value
    ;   |  |  |  |  |  +-------------------------------- [10] GPIO_DIN[26]  data in value
    ;   |  |  |  |  +----------------------------------- [11] GPIO_DIN[27]  data in value
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] GPIO_DIN[28]  data in value
    ;   |  |  +----------------------------------------- [13] GPIO_DIN[29]  data in value
    ;   |  +-------------------------------------------- [14] GPIO_DIN[30]  data in value
    ;   +----------------------------------------------- [15] GPIO_DIN[31]  data in value


GPIO_DOUT0              .set    0x1C0A
GPIO_DOUT               .set    0x1C0A
    ; GPIO_DOUT0/GPIO_DOUT   Address:  0x1C0A (IO space)  GPIO Data Out Register 0
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  GPIO_DOUT[0]   data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  GPIO_DOUT[1]   data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  GPIO_DOUT[2]   data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  GPIO_DOUT[3]   data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  GPIO_DOUT[4]   data out value
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  GPIO_DOUT[5]   data out value
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  GPIO_DOUT[6]   data out value
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  GPIO_DOUT[7]   data out value
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  GPIO_DOUT[8]   data out value
    ;   |  |  |  |  |  |  +----------------------------- [9]  GPIO_DOUT[9]   data out value
    ;   |  |  |  |  |  +-------------------------------- [10] GPIO_DOUT[10]  data out value
    ;   |  |  |  |  +----------------------------------- [11] GPIO_DOUT[11]  data out value
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] GPIO_DOUT[12]  data out value
    ;   |  |  +----------------------------------------- [13] GPIO_DOUT[13]  data out value
    ;   |  +-------------------------------------------- [14] GPIO_DOUT[14]  data out value
    ;   +----------------------------------------------- [15] GPIO_DOUT[15]  data out value

GPIO_DOUT1              .set    0x1C0B
    ; GPIO_DOUT1   Address:  0x1C0B (IO space)           GPIO Data Out Register 1
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  GPIO_DOUT[16]  data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  GPIO_DOUT[17]  data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  GPIO_DOUT[18]  data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  GPIO_DOUT[19]  data out value
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  GPIO_DOUT[20]  data out value
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  GPIO_DOUT[21]  data out value
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  GPIO_DOUT[22]  data out value
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  GPIO_DOUT[23]  data out value
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  GPIO_DOUT[24]  data out value
    ;   |  |  |  |  |  |  +----------------------------- [9]  GPIO_DOUT[25]  data out value
    ;   |  |  |  |  |  +-------------------------------- [10] GPIO_DOUT[26]  data out value
    ;   |  |  |  |  +----------------------------------- [11] GPIO_DOUT[11]  data out value
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] GPIO_DOUT[12]  data out value
    ;   |  |  +----------------------------------------- [13] GPIO_DOUT[13]  data out value
    ;   |  +-------------------------------------------- [14] GPIO_DOUT[14]  data out value
    ;   +----------------------------------------------- [15] GPIO_DOUT[15]  data out value

CLKSTOP         .set    0x1C3A
    ; CLKSTOP   Address:  0x1C3A (IO Space)           Clock Stop Request/Acknowledge Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :rw|r :rw:r :rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: x: 0| x: 0: x: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  EMIF_CLKSTOP_REQ    (0:normal, 1:request permission to stop the clock)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  EMIF_CLKSTOP_ACK    (status register: 0:not ok to stop the clock, 1:ok to stop the clock)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  USB_CLKSTOP_REQ     (0:normal, 1:request permission to stop the clock)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  USB_CLKSTOP_ACK     (status register: 0:not ok to stop the clock, 1:ok to stop the clock)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  UART_CLKSTOP_REQ    (0:normal, 1:request permission to stop the clock)
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  UART_CLKSTOP_ACK    (status register: 0:not ok to stop the clock, 1:ok to stop the clock)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved

;----------------------------------------------------------------------------------------
;        CLK STOP Register Bit Fields 
;----------------------------------------------------------------------------------------
EMIF_CLKSTOP_REQ                .set    1b<<0     ; Request permission to stop EMIF internal clock
EMIF_CLKSTOP_ACK                .set    1b<<1     ; EMIF clock stop request status
USB_CLKSTOP_REQ                 .set    1b<<2     ; Request permission to stop USB internal clock
USB_CLKSTOP_ACK                 .set    1b<<3     ; USB clock stop request status
UART_CLKSTOP_REQ                .set    1b<<4     ; Request permission to stop UART internal clock
UART_CLKSTOP_ACK                .set    1b<<5     ; UART clock stop request status
;****************************************************************************************

;****************************************************************************************
PIN_CONFIG              .set    0x1C1E
CONFIG_LSW              .set    0x1C1E
    ; PIN_CONFIG/CONFIG_LSW   Address:  0x1C1E (IO space)      Configuration LSW Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :r |r :r :r :rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  ExtOscResEn       (0:XI & XO pins have internal 1Mohm resistor between them, 1:XI & XO have no internal resistor between them (external resistor required))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  reserved
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved

CONFIG_MSW              .set    0x1C1F
    ; CONFIG_MSW   Address:  0x1C1F (IO space)           Clock Configuration MSW Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :r |rw:r :r :rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0:??: 0| 0:??: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  SysClkSel        (0:PLL Bypassed (sysclk=osc), 1:PLL used (sysclk=pllout))
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  CLK_SEL_PIN      (read only - reads the state of the CLK_SEL pin; writes have no affect)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  Timer0ClkSel     (0:normal mode/same as all other peripherals (sysclk), 1:PLL used (Timer0clk <= pllout) (testmode for pll))
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  SysClkSelStatus[0]  (Read Only Status of Glitch-Free-Clock Mux's selected clk source:
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  SysClkSelStatus[1]   00:RTCXI, 01:PLL out, 10:CLKIN pin, 11:PLL out)   (note: bit1 is identical to CLK_SEL_PIN, bit0 is the pll used vs bypassed status)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved

;****************************************************************************************
;    Clock Config Control Register Bit Fields
;****************************************************************************************
SYS_PLL_BYPASS      .set    0b << 0     ; System clock has PLL Bypassed
SYS_PLL_SEL         .set    1b << 0     ; System clock has PLL Selected
SAR_PLL_BYPASS      .set    0b << 1     ; SAR clock has PLL Bypassed
CLK_SEL_STAT        .set    2           ; To test the status fo the CLK_SEL_PIN
OSC_INT_RES_EN      .set    0b << 0     ; Osciallator internal 1MOhm reistance enabled
OSC_INT_RES_DIS     .set    1b << 0     ; Osciallator internal 1MOhm reistance disabled
TIMER0_SYSCLK       .set    0b << 3     ; Timer0 clock is the same as the system clock
TIMER0_OSCCLK       .set    1b << 3     ; Timer0 clock derived before PLL (Oscillator or CLKIN) (Incorrect description, see below)
TIMER0_PLLCLK       .set    1b << 3     ; Timer0 clock derived from PLL
;****************************************************************************************


CLKOUT_CFG              .set    0x1C24
    ; CLKOUT_CFG   Address:  0x1C24 (IO space)           CLKOUT Clock Source Select Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :r |rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 1: 0: 1: 1|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |        *** This clock selector is not a glitch-free clock switcher! ***
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  clkout_src(0)    # CLKOUT_SRC[3:0]      CLKOUT Selected                 Comment
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  clkout_src(1)    # ===============      ============================    =====================================
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  clkout_src(2)    # 0000                 SYSPLL_VCO_Output               (** Quietest for testing SYS PLL ***)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  clkout_src(3)    # 0001                 1'b1
    ;   |  |  |  |  |  |  |  |  |  |  |  |                                     # 0010                 SYSPLL_VCO_Output
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  reserved         # 0011                 1'b0
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  reserved         # 0100                 SYSPLL_VCO_Output
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved         # 0101                 1'b0
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved         # 0110                 SYSPLL_VCO_Output
    ;   |  |  |  |  |  |  |  |                                                 # 0111                 USB_PHYCLKOUT                   (** Quietest for testing USB PLL ***)
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved         # 1000                 SYSPLL_VCO_Output
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved         # 1001                 SARClock
    ;   |  |  |  |  |  +-------------------------------- [10] reserved         # 1010                 SYSPLL_VCO_Output
    ;   |  |  |  |  +----------------------------------- [11] reserved         # 1011                 DSP Clock                       (** CLKOUT_SRC[3:0] reset state **)
    ;   |  |  |  |                                                             # 1100                 SYSPLL_VCO_Output
    ;   |  |  |  +-------------------------------------- [12] reserved         # 1101                 GlitchFreeClkMuxOut
    ;   |  |  +----------------------------------------- [13] reserved         # 1110                 SYSPLL_VCO_Output
    ;   |  +-------------------------------------------- [14] reserved         # 1111                 USB_PHYCLKOUT
    ;   +----------------------------------------------- [15] reserved

USB_CNTL            .set    0x1C32                      ; USB System Control Register
    ; USB_CNTL             Address:  0x1C32 (IO space)       USB System Control Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|r :r :r :r |r :rw:r :r |rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 1: 0: 1: 0| 0: 0: 0: 0| 0: 1: 0: 0| 1: 1: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  USB_BYTEMODE[0]         (0:word accesses, 1:hi byte access)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  USB_BYTEMODE[1]         (0:word accesses, 1:low byte access)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  USB_OSC_GZ              (0:normal operating mode, 1:oscillator disabled/XO is tristate/Y is low)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  USB_OSC_PWRDN           (0:normal operating mode WITH internal bias resistor, 1:normal operationg mode WITHOUT internal bias resistor/resistor is external/tester mode)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  reserved
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  USB_NORMALDATAPOLARITY  (0:Reverse polarity of DP & DM, 1:Normal Polarity)
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] USB_PLLON               (0:Normal USB behavior, 1:override USB SUSPENDM behavior and force release of PLL from suspend state)
    ;   |  |  +----------------------------------------- [13] USB_VBUSDETECTEN        (0:VBUS Comparators OFF (except sessionend comparator), 1:Comparators ON)
    ;   |  +-------------------------------------------- [14] USB_SESSENDEN           (0:VBUS SESSIONEND comparator OFF, 1:VBUS SESSIONEND comparator ON)
    ;   +----------------------------------------------- [15] USB_PD                  (0:USB powered, 1:USB powered-down)



;****************************************************************************************
;        Clock Domain Registers
;****************************************************************************************
IDLE_ICR        .set    0x0001        ; IDLE Control Register
    ; IDLE_ICR   Address:  0x0001 (IO Space)             IDLE Control Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 1: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  CPU_IDLE          (0:active, 1:idled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  reserved, writes should set to 1
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  reserved, writes should set to 1
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  reserved, writes should set to 1
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  CLK_IDLE  *** reserved, writes should set to 0 ***
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  DPORT_IDLE        (0:active, 1:idled)
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  XPORT_IDLE        (0:active, 1:idled - CPUI must be idled too)
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  MPORT_IDLE        (0:active, 1:idled - DMA must be idled too)
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  IPORT_IDLE        (0:active, 1:idled)
    ;   |  |  |  |  |  |  +----------------------------- [9]  HWA_IDLE          (0:active, 1:idled)
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved

;----------------------------------------------------------------------------------------
;        ICR Bit Fields
;----------------------------------------------------------------------------------------
CPU_IDLE        .set    1b          ; CPU Idle Control Bit
CLK_IDLE        .set    1b<<4       ; Clock Generator Idle Control Bit
DPORT_IDLE      .set    1b<<5       ; DPORT Idle Control Bit
XPORT_IDLE      .set    1b<<6       ; XPORT Idle Control Bit
MPORT_IDLE      .set    1b<<7       ; MPORT Idle Control Bit
IPORT_IDLE      .set    1b<<8       ; IPORT Idle Control Bit
HWA_IDLE        .set    1b<<9       ; HWA Idle Control Bit
RESERVED_ICR    .set    1111110000001110b       ; Reserved bits (UMA peripheral, DMA, cache)

RTC_OSC             .set    0x192c        ; RTC Oscillator Register
    ; RTC_OSC   Address:  0x192c (IO space)              RTC Oscillator Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |rw:r :r :r |r :r :r :r |rw:rw:rw:rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 1: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  OscResistance[0]  (Oscillator Performance Control -
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  OscResistance[1]   1000:Least Current Mode,
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  OscResistance[2]   1011:Fast Startup Mode,
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  OscResistance[3]   others:reserved)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  OscPowerDown      (0:osc enabled, 1:osc disabled & bypass testmode (RTCXI->Y : tester can drive a high speed clock into RTCXI))
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  reserved
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] SWReset           (0:RTC not in reset, 1:RTC in reset)

RTC_LDORTCWAKE   .set    0x1930        ; RTC Power Management Control Register
RTC_PMGT         .set    0x1930        ; RTC Power Management Control Register
    ; RTC_PMGT   Address:  0x1930 (IO space)              RTC Power Management Control Register
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | w:r :r :r |r :r :r :r |r :r :r :rw|rw:rw:rw:rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 1| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  CLKOUTEN (1: rtc clock output is enabled; 0 disabled)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  LDO_PD   (1: LDO Powerdown)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  BG_PD    (1: Bandgap Powerdown)
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  WU_DIR   (0: Wakeup pin is active high INPUT; 1: wakeup is an active low open-drain OUTPUT)
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  WU_DOUT  (0: Wakeup output pin is driven low; 1: wakeup pin is open drain output 'z')
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  reserved
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved

USB_ANA_CNTL            .set    0x7004
    ; USB_ANA_CNTL   Address:  0x7004 (IO space)              USB Control
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ; |15:14:13:12|11:10: 9: 8| 7: 6: 5: 4| 3: 2: 1: 0|  <<== Bit Position
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; |r :r :r :r |r :r :r :r |r :r :r :r |r :r :r :rw|  <<== Read / Write Access
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--:--:--+
    ; | 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0| 0: 0: 0: 0|  <<== Reset Values
    ; +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  +-- [0]  usb_ldo_en      [0:disabled (w/output tristated), 1:enabled]
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  |  +----- [1]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |  |  +-------- [2]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |  +----------- [3]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  |  |  |  |  +-------------- [4]  reserved
    ;   |  |  |  |  |  |  |  |  |  |  +----------------- [5]  reserved
    ;   |  |  |  |  |  |  |  |  |  +-------------------- [6]  reserved
    ;   |  |  |  |  |  |  |  |  +----------------------- [7]  reserved
    ;   |  |  |  |  |  |  |  |
    ;   |  |  |  |  |  |  |  +-------------------------- [8]  reserved
    ;   |  |  |  |  |  |  +----------------------------- [9]  reserved
    ;   |  |  |  |  |  +-------------------------------- [10] reserved
    ;   |  |  |  |  +----------------------------------- [11] reserved
    ;   |  |  |  |
    ;   |  |  |  +-------------------------------------- [12] reserved
    ;   |  |  +----------------------------------------- [13] reserved
    ;   |  +-------------------------------------------- [14] reserved
    ;   +----------------------------------------------- [15] reserved
